import { Http,Util } from '@/utils';
import EntityService from '../entity-service';



/**
 * 职务证书服务对象基类
 *
 * @export
 * @class HRDutyCertServiceBase
 * @extends {EntityServie}
 */
export default class HRDutyCertServiceBase extends EntityService {

    /**
     * Creates an instance of  HRDutyCertServiceBase.
     * 
     * @param {*} [opts={}]
     * @memberof  HRDutyCertServiceBase
     */
    constructor(opts: any = {}) {
        super(opts);
    }

    /**
     * 初始化基础数据
     *
     * @memberof HRDutyCertServiceBase
     */
    public initBasicData(){
        this.APPLYDEKEY ='hrdutycert';
        this.APPDEKEY = 'hrdutycertid';
        this.APPDENAME = 'hrdutycerts';
        this.APPDETEXT = 'hrdutycertname';
        this.APPNAME = 'pim';
        this.SYSTEMNAME = 'ibizhumanresources';
    }

// 实体接口

    /**
     * Select接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRDutyCertServiceBase
     */
    public async Select(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hrduty && context.hrdutycert){
            let res:any = Http.getInstance().get(`/hrduties/${context.hrduty}/hrdutycerts/${context.hrdutycert}/select`,isloading);
            
            return res;
        }
            let res:any = Http.getInstance().get(`/hrdutycerts/${context.hrdutycert}/select`,isloading);
            
            return res;
    }

    /**
     * Create接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRDutyCertServiceBase
     */
    public async Create(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hrduty && true){
            let masterData:any = {};
            Object.assign(data,masterData);
            if(!data.srffrontuf || data.srffrontuf !== "1"){
                data[this.APPDEKEY] = null;
            }
            if(data.srffrontuf){
                delete data.srffrontuf;
            }
            let tempContext:any = JSON.parse(JSON.stringify(context));
            let res:any = await Http.getInstance().post(`/hrduties/${context.hrduty}/hrdutycerts`,data,isloading);
            
            return res;
        }
        let masterData:any = {};
        Object.assign(data,masterData);
        if(!data.srffrontuf || data.srffrontuf !== "1"){
            data[this.APPDEKEY] = null;
        }
        if(data.srffrontuf){
            delete data.srffrontuf;
        }
        let tempContext:any = JSON.parse(JSON.stringify(context));
        let res:any = await Http.getInstance().post(`/hrdutycerts`,data,isloading);
        
        return res;
    }

    /**
     * Update接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRDutyCertServiceBase
     */
    public async Update(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hrduty && context.hrdutycert){
            let masterData:any = {};
            Object.assign(data,masterData);
            let res:any = await Http.getInstance().put(`/hrduties/${context.hrduty}/hrdutycerts/${context.hrdutycert}`,data,isloading);
            
            return res;
        }
        let masterData:any = {};
        Object.assign(data,masterData);
            let res:any = await  Http.getInstance().put(`/hrdutycerts/${context.hrdutycert}`,data,isloading);
            
            return res;
    }

    /**
     * Remove接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRDutyCertServiceBase
     */
    public async Remove(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hrduty && context.hrdutycert){
            let res:any = Http.getInstance().delete(`/hrduties/${context.hrduty}/hrdutycerts/${context.hrdutycert}`,isloading);
            return res;
        }
            let res:any = Http.getInstance().delete(`/hrdutycerts/${context.hrdutycert}`,isloading);
            return res;
    }

    /**
     * Get接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRDutyCertServiceBase
     */
    public async Get(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hrduty && context.hrdutycert){
            let res:any = await Http.getInstance().get(`/hrduties/${context.hrduty}/hrdutycerts/${context.hrdutycert}`,isloading);
            
            return res;
        }
            let res:any = await Http.getInstance().get(`/hrdutycerts/${context.hrdutycert}`,isloading);
            
            return res;
    }

    /**
     * GetDraft接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRDutyCertServiceBase
     */
    public async GetDraft(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hrduty && true){
            let res:any = await Http.getInstance().get(`/hrduties/${context.hrduty}/hrdutycerts/getdraft`,isloading);
            res.data.hrdutycert = data.hrdutycert;
            
            return res;
        }
        let res:any = await  Http.getInstance().get(`/hrdutycerts/getdraft`,isloading);
        res.data.hrdutycert = data.hrdutycert;
        
        return res;
    }

    /**
     * CheckKey接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRDutyCertServiceBase
     */
    public async CheckKey(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hrduty && context.hrdutycert){
            let masterData:any = {};
            Object.assign(data,masterData);
            let res:any = await Http.getInstance().post(`/hrduties/${context.hrduty}/hrdutycerts/${context.hrdutycert}/checkkey`,data,isloading);
            
            return res;
        }
            let res:any = Http.getInstance().post(`/hrdutycerts/${context.hrdutycert}/checkkey`,data,isloading);
            return res;
    }

    /**
     * Save接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRDutyCertServiceBase
     */
    public async Save(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hrduty && context.hrdutycert){
            let masterData:any = {};
            Object.assign(data,masterData);
            let res:any = await Http.getInstance().post(`/hrduties/${context.hrduty}/hrdutycerts/${context.hrdutycert}/save`,data,isloading);
            
            return res;
        }
        let masterData:any = {};
        Object.assign(data,masterData);
            let res:any = await  Http.getInstance().post(`/hrdutycerts/${context.hrdutycert}/save`,data,isloading);
            
            return res;
    }

    /**
     * FetchDefault接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRDutyCertServiceBase
     */
    public async FetchDefault(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hrduty && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            let res:any = Http.getInstance().get(`/hrduties/${context.hrduty}/hrdutycerts/fetchdefault`,tempData,isloading);
            return res;
        }
        let tempData:any = JSON.parse(JSON.stringify(data));
        let res:any = Http.getInstance().get(`/hrdutycerts/fetchdefault`,tempData,isloading);
        return res;
    }
}